Subject: Re: [PATCH] add-zle-hook-widget zle-line-pre-redraw issue
From: Daniel Shahaf <[email-masked]>
To: [email-masked]
Date: Sun, 24 Jul 2016 21:30:46 +0000
List-Id: Zsh Workers List <zsh-workers.zsh.org>

Bart Schaefer wrote on Sat, Jul 23, 2016 at 18:14:45 -0700:
> On Jul 23,  9:23pm, Daniel Shahaf wrote:
> }
> } The reason appears to be that, while in azhw:zle-line-init $WIDGET is
> } "zle-line-init", in azhw:zle-line-pre-redraw $WIDGET is the name of the
> } widget the user invoked (e.g., "self-insert"), so the 'zstyle -a' does
> } not find the registered hooks.
> 
> If zsh-syntax-highlighting doesn't depend on that behavior, it's probably
> unlikely that anything else does.

z-sy-h assumes that zle-line-finish sets $WIDGET, but doesn't assume
anything else about $WIDGET.

> } Each of the following alternative patches solves the issue:
> 
> The "second option" obviously isn't finished / leaves a lot of dead
> code behind.

Indeed it isn't: the unidiff I'd sent was not the unidiff I would commit
if that option is chosen.  Its purpose was not to be committed as is,
only to unambiguously explain what the second alternative was.

Sorry if that wasn't clear.

> However, I think the first option is the correct one,
> unless there's a good reason to leave $WIDGET alone; the context
> that's being saved/restored by redrawhook() is important, because
> we're in the middle of an arbitrary other widget
> 
> This is actually related to what I was saying about it not being
> appropriate to stick a list of callbacks on any widget.
> 
> We can easily special-case add-zle-hook-widget to find the name another
> way for this particular hook.  $funcstack[1] for example.

Okay, so let's wait for Mikael to weigh in, then we can choose between
making pre-redraw set $WIDGET or making a-z-h-w handle pre-redraw's not
doing so.

> Incidentally, I tried making ALL the possible hooks be
> 
>     zle -M "$WIDGET $funcstack[1]"
> 
> and learned two things.  (1) pre-redraw is in fact the only hook that
> doesn't change $WIDGET, and (2) having all the hooks call "zle -M"
> garbles the output quite thoroughly, especially in vi mode.

Thanks for checking (1).  I can reproduce (2), the prompt character
doesn't render and <accept-line> doesn't move down the screen.

Cheers,

Daniel